#include <linux/fb.h>


struct display {
	ushort scr_max_height;			/* screen dimensions */
	ushort scr_max_width;
	ushort scr_height;
	ushort scr_width;
	ushort scr_depth;
	int bytes_per_row;			/* offset to one line below */

	int cursor_x;				/* current cursor position */
	int cursor_y;

	ulong fgcol;				/* 24-bit text colors */
	ulong bgcol;
	ulong crsrcol;

	struct fb_var_screeninfo var;		/* variable infos */
	struct fb_cmap	cmap;			/* colormap */

	u_char *fontdata;			/* Font associated to this display */
	int fontheight;
	int fontwidth;

	ushort scroll_latch;			/* Vblank support for hardware scroll */
	ushort y_wrap;
	ushort cursor_latch;			/* Hardware cursor */
	ushort *cursor, *dummy;
	ushort cursor_flash;
	ushort cursor_visible;

	/* Some chipreg values we need to rebuild copper lists */
	ushort diwstrt_v, diwstrt_h;		/* display window control */
	ushort diwstop_v, diwstop_h;
	ushort bplcon0;				/* display mode */
	ushort htotal;

	u_char *bitplane[8];			/* pointers to display bitplanes */
	ulong plane_size;

	ushort *coplist1hdr;			/* List 1 static  component */
	ushort *coplist1dyn;			/* List 1 dynamic component */
	ushort *coplist2hdr;			/* List 2 static  component */
	ushort *coplist2dyn;			/* List 2 dynamic component */

	struct display_switch *dispsw;		/* pointers to depth specific functions */
}; 

struct fb_info {
	char modename[40];					/* name of the at boottime detected video mode */
	struct display *disp;				/* pointer to display variables */
	int (*changevar)(int);				/* tell the console var has changed */
	int (*switch_con)(int);				/* tell the framebuffer to switch consoles */
	int (*updatevar)(int);				/* tell the framebuffer to update the vars */
	void (*blank)(int);					/* tell the framebuffer to (un)blank the screen */
};

struct fb_info *amifb_init(long *);
