/*
 *  linux/include/linux/config.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file README.legal in the main directory of this archive
 * for more details.
 */

#ifndef _LINUX_CONFIG_H
#define _LINUX_CONFIG_H

#include <linux/autoconf.h>

/*
 * Defines for what uname() should return
 */
#ifndef UTS_SYSNAME
#define UTS_SYSNAME "Linux"
#endif

#ifndef UTS_NODENAME
#define UTS_NODENAME "(none)"   /* set by sethostname() */
#endif

#ifndef UTS_MACHINE
#define UTS_MACHINE "m68k"     /* hardware type */
#endif

#ifndef UTS_DOMAINNAME
#define UTS_DOMAINNAME "(none)" /* set by setdomainname() */
#endif


/*
 * The definitions for UTS_RELEASE and UTS_VERSION are now defined
 * in linux/version.h, and should only be used by linux/version.c
 */

/* interrupt service routine function ptr type */
struct intframe;
#ifndef ISRFUNC_T
typedef void (*isrfunc) (struct intframe *fp, void *data);
#define ISRFUNC_T
#endif /* ISRFUNC_T */

extern void (*mach_sched_init) (isrfunc);
extern unsigned long (*mach_keyb_init) (unsigned long);
struct kbd_repeat;
extern int (*mach_kbdrate) (struct kbd_repeat *);
extern void (*mach_init_INTS) (void);
extern int (*mach_add_isr) (unsigned long source, isrfunc isr,
			    int pri, void *data);
extern void (*mach_process_int) (int level, struct intframe *fp);
extern unsigned long (*mach_gettimeoffset)(void);
struct mktime;
extern void (*mach_gettod)(struct mktime*);
struct hwclk_time;
extern int (*mach_hwclk)(int, struct hwclk_time*);
extern int (*mach_set_clock_mmss)(unsigned long);
struct gendisk;
extern void (*mach_check_partition) (struct gendisk *hd, unsigned int dev);
extern void (*mach_mksound)( unsigned int count, unsigned int ticks );
extern void (*mach_reset)( void );
extern void (*mach_floppy_init) (void);
struct buffer_head;
extern int (*mach_floppy_change) (struct buffer_head *bh);
extern unsigned long (*mach_hd_init) (unsigned long, unsigned long);
extern void (*mach_hd_setup)(char *, int *);
extern void (*waitbut)(void);

#endif /* linux/config.h */
